> ## Documentation Index
> Fetch the complete documentation index at: https://docs.3ngram.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Unified semantic + keyword retrieval (mirrors the MCP search tool)



## OpenAPI

````yaml /api-reference/openapi.json post /api/v1/search
openapi: 3.1.0
info:
  description: >-
    The /api/v1 REST mirror of the 3ngram memory core
    (docs/concepts/architecture.mdx: one core, N transports). Authenticate with
    an X-API-Key header or a session Bearer token.
  title: 3ngram REST API
  version: v1
servers:
  - description: 3ngram platform
    url: https://api.3ngram.ai
security:
  - apiKey: []
  - sessionBearer: []
paths:
  /api/v1/search:
    post:
      summary: Unified semantic + keyword retrieval (mirrors the MCP search tool)
      operationId: search
      requestBody:
        content:
          application/json:
            schema:
              additionalProperties: false
              properties:
                asOf:
                  additionalProperties: false
                  properties:
                    asKnownAt:
                      format: date-time
                      pattern: >-
                        ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                      type: string
                    validAt:
                      format: date-time
                      pattern: >-
                        ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                      type: string
                  type: object
                limit:
                  default: 5
                  maximum: 25
                  minimum: 1
                  type: integer
                memoryType:
                  enum:
                    - decision
                    - commitment
                    - blocker
                    - fact
                    - preference
                    - pattern
                    - note
                    - event
                  type: string
                project:
                  maxLength: 256
                  minLength: 1
                  type: string
                query:
                  minLength: 1
                  type: string
                scope:
                  maxLength: 64
                  minLength: 1
                  pattern: ^[a-z0-9][a-z0-9-]*$
                  type: string
                status:
                  enum:
                    - active
                    - archived
                  type: string
              required:
                - query
              type: object
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                additionalProperties: false
                properties:
                  count:
                    maximum: 9007199254740991
                    minimum: 0
                    type: integer
                  hits:
                    items:
                      additionalProperties: false
                      properties:
                        content:
                          maxLength: 600
                          type: string
                        contentLength:
                          maximum: 9007199254740991
                          minimum: 0
                          type: integer
                        id:
                          format: uuid
                          pattern: >-
                            ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                          type: string
                        memoryType:
                          type: string
                        score:
                          type: number
                        topic:
                          type: string
                        truncated:
                          type: boolean
                      required:
                        - id
                        - memoryType
                        - topic
                        - content
                        - contentLength
                        - truncated
                        - score
                      type: object
                    maxItems: 25
                    type: array
                required:
                  - hits
                  - count
                type: object
          description: Success
components:
  securitySchemes:
    apiKey:
      in: header
      name: X-API-Key
      type: apiKey
    sessionBearer:
      scheme: bearer
      type: http

````